## yubico-piv-tool-2.1.1.tar.gz

=== CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required (VERSION 3.5)
cmake_policy(SET CMP0025 NEW)
set (CMAKE_C_STANDARD 99)

project (yubico-piv-tool)

set (yubico_piv_tool_VERSION_MAJOR 2)
set (yubico_piv_tool_VERSION_MINOR 1)
set (yubico_piv_tool_VERSION_PATCH 1)
set (VERSION "${yubico_piv_tool_VERSION_MAJOR}.${yubico_piv_tool_VERSION_MINOR}.${yubico_piv_tool_VERSION_PATCH}")
set (SO_VERSION 1)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
include(${CMAKE_SOURCE_DIR}/cmake/options.cmake)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif()

include(CheckCCompilerFlag)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(WIN32)
    add_definitions(-DWIN32_LEAN_AND_MEAN)
    set(_WIN32 ${WIN32})
    set(_WINDOWS ${WIN32})
endif()

if(MSVC)
    if((NOT GETOPT_LIB_DIR) OR (NOT GETOPT_INCLUDE_DIR))
        message(FATAL_ERROR "please provide definitions for "
                "GETOPT_LIB_DIR and GETOPT_INCLUDE_DIR when building "
                "under msvc")
    endif()
    if(SUPRESS_MSVC_WARNINGS)
        set(MSVC_DISABLED_WARNINGS_LIST
            "C4200" # nonstandard extension used: zero-sized array in struct/union;
            "C4204" # nonstandard extension used: non-constant aggregate initializer;
            "C4706" # assignment within conditional expression;
            "C4996" # The POSIX name for this item is deprecated. Instead, use the ISO C and C++ conformant name

            "C4473" # Not enough arguments passed for format string placeholders
            "C4244" # Conversion from 'int' to 'unsigned char', possible loss of data
            "C4152" # Nonstandard extension, function/data pointer conversion in expression (openssl/applink.c)
            "C4068" # Unknown pragma
            "C4701" # Potentially uninitialized local variable
            "C4703" # Potentially uninitialized local pointer
            "C4100" # 'param': unreferenced formal parameter (unsupported pkcs11 functions)
            "C4221" # Nonstandard extension used: 'pValue': cannot be initialized using address of automatic variable (ykcs11_tests_util)
            "C4057" # 'const char *' differs in indirection to slightly different base types from 'const CK_CHAR_PTR' (ykcs11 tests)
            "C4245" # Conversion from 'int' to 'CK_ULONG' (ykcs11 tests)
            "C4013" # '_getpid' undefined; assuming extern returning int (ykcs11/utils.c)
            "C4702" # Unreachable code (mechanisms.c:is_RSA_mechanism)
            "C4133" # Incompatible types: from 'ykpiv_rc' (enum) to 'int'
            "C4267" # Conversion from 'size_t' to 'CK_ULONG'
            "C4312" # Conversion from 'unsigned int' to 'void *' of greater size (ykcs11/utils.c:noop_create_mutex)
            )
        # The construction in the following 3 lines was taken from LibreSSL's
        # CMakeLists.txt.
        string(REPLACE "C" " -wd" MSVC_DISABLED_WARNINGS_STR ${MSVC_DISABLED_WARNINGS_LIST})
        string(REGEX REPLACE "[/-]W[1234][ ]?" "" CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -MP -W4 ${MSVC_DISABLED_WARNINGS_STR}")
    endif(SUPRESS_MSVC_WARNINGS)

    set(BUILD_SHARED_LIBS ON)
    set(GENERATE_MAN_PAGES OFF)
    set(LIBCRYPTO_LIBRARIES ${LIBCRYPTO_LIBRARIES} bcrypt)
else()
    find_package (PkgConfig REQUIRED)

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w") # -g -O2
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Werror")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wwrite-strings")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wbad-function-cast")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pedantic")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")

    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -g2")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer")
endif()

# Use -Wshorten-64-to-32 if available.
check_c_compiler_flag("-Wshorten-64-to-32" HAVE_SHORTEN_64_TO_32)
if(HAVE_SHORTEN_64_TO_32)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshorten-64-to-32")
endif()

# Avoid https://gcc.gnu.org/bugzilla/show_bug.cgi?id=66425
if(CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-result")
endif()

include(${CMAKE_SOURCE_DIR}/cmake/openssl.cmake)
find_libcrypto()
include_directories(${LIBCRYPTO_INCLUDE_DIRS})

enable_testing()
find_package(codecov)

add_subdirectory (lib)
if(NOT BUILD_ONLY_LIB)
    add_subdirectory(ykcs11)
    add_subdirectory(tool)
endif()

coverage_evaluate()

message("Build summary:")
message("")
message("        Project name:     ${CMAKE_PROJECT_NAME}")
message("        Version:          ${VERSION}")
message("        Host type:        ${CMAKE_SYSTEM_NAME}")
message("        Install prefix:   ${CMAKE_PREFIX_PATH}")
message("        Compiler:         ${CMAKE_C_COMPILER}")
message("        Compiler ID:      ${CMAKE_C_COMPILER_ID}")
message("        CFLAGS:           ${CMAKE_C_FLAGS}")
message("        CPPFLAGS:         ${CMAKE_CXX_FLAGS}")
message("        Warnings:         ${WARN_FLAGS}")
message("        Build type:       ${CMAKE_BUILD_TYPE}")
message("        Backend:          ${BACKEND}")
message("        PCSC")
message("                CFLAGS:   ${PCSC_CFLAGS}")
message("                LIBS:     ${PCSC_LIBRARIES}")
message("        Winscard")
message("                LIBS:     ${PCSC_WIN_LIBS}")
message("        Mac PCSC")
message("                LIBS:     ${PCSC_MACOSX_LIBS}")
message("        Custom PCSC")
message("                LIBS:     ${PCSC_CUSTOM_LIBS}")
message("")
message("        Install prefix:    ${CMAKE_INSTALL_PREFIX}")
message("        Install targets")
message("                Libraries  ${YKPIV_INSTALL_LIB_DIR}")
message("                Includes   ${YKPIV_INSTALL_INC_DIR}")
message("                Binaries   ${YKPIV_INSTALL_BIN_DIR}")
message("                Manuals    ${YKPIV_INSTALL_MAN_DIR}")
message("                Pkg-config ${YKPIV_INSTALL_PKGCONFIG_DIR}")
message("")
message("        YKCS11 debug:     ${ENABLE_YKCS11_DBG}")
message("        Hardware tests:   ${ENABLE_HARDWARE_TESTS}")

=== tool/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("tool/CMakeList.txt")

set (SOURCE
        yubico-piv-tool.c
        ../common/openssl-compat.c
        ../common/util.c)

if(WIN32)
    add_definitions (-DPACKAGE="yubico-piv-tool")
    add_definitions (-DVERSION="${yubico_piv_tool_VERSION_MAJOR}.${yubico_piv_tool_VERSION_MINOR}.${yubico_piv_tool_VERSION_PATCH}")

    set(SOURCE ${SOURCE} cmdline.c)

    find_library(GETOPT getopt PATHS ${GETOPT_LIB_DIR})
    set(LINK_LIBS_WIN ${GETOPT})
    include_directories(${GETOPT_INCLUDE_DIR})
else(WIN32)
    include(${CMAKE_SOURCE_DIR}/cmake/gengetopt.cmake)
    find_gengetopt()
    add_gengetopt_files(cmdline)
    set(SOURCE ${SOURCE} ${GGO_C})
endif(WIN32)

include_directories (
        ${CMAKE_SOURCE_DIR}/lib
        ${CMAKE_CURRENT_SOURCE_DIR}
)

add_executable (yubico-piv-tool ${SOURCE})
target_link_libraries(yubico-piv-tool ${LIBCRYPTO_LDFLAGS} ${LINK_LIBS_WIN} ykpiv_shared)
add_coverage(yubico-piv-tool)

set_target_properties(yubico-piv-tool PROPERTIES INSTALL_RPATH "${YKPIV_INSTALL_LIB_DIR}")
install(
        TARGETS yubico-piv-tool
        ARCHIVE DESTINATION "${YKPIV_INSTALL_LIB_DIR}"
        LIBRARY DESTINATION "${YKPIV_INSTALL_LIB_DIR}"
        RUNTIME DESTINATION "${YKPIV_INSTALL_BIN_DIR}")

if (GENERATE_MAN_PAGES)
    include (${CMAKE_SOURCE_DIR}/cmake/help2man.cmake)
    add_help2man_manpage (yubico-piv-tool.1 yubico-piv-tool)

    add_custom_target (yubico-piv-tool-man ALL DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/yubico-piv-tool.1)
endif(GENERATE_MAN_PAGES)

find_file(MAN_PAGE yubico-piv-tool.1 PATHS ${CMAKE_CURRENT_SOURCE_DIR})
if(MAN_PAGE)
    install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/yubico-piv-tool.1" DESTINATION "${YKPIV_INSTALL_MAN_DIR}/man1")
endif(MAN_PAGE)

add_subdirectory(tests)

=== lib/tests/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#   * Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
#   * Redistributions in binary form must reproduce the above
#     copyright notice, this list of conditions and the following
#     disclaimer in the documentation and/or other materials provided
#     with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("lib/tests/CMakeList.txt")

if(CMAKE_C_COMPILER_ID MATCHES Clang)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIE")
elseif(NOT MSVC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIE -pie")
endif()

include(check)
find_check()

if(NOT DEFINED SKIP_TESTS)
    set(SOURCE_BASIC basic.c)
    set(SOURCE_API api.c)
    set(SOURCE_PARSE_KEY parse_key.c)

    add_executable (test_basic ${SOURCE_BASIC})
    add_executable(test_api ${SOURCE_API})
    add_executable(test_parse_key ${SOURCE_PARSE_KEY})

    target_link_libraries(test_basic ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})
    target_link_libraries(test_api ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})
    target_link_libraries(test_parse_key ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})

    add_test(
        NAME basic
        COMMAND test_basic
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
    )

    add_test(
        NAME api
        COMMAND test_api
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
    )

    add_test(
        NAME parse_key
        COMMAND test_parse_key
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
    )
endif(NOT DEFINED SKIP_TESTS)

=== debian/changelog ===
yubico-piv-tool (2.1.1) stable; urgency=medium

  * 2.1.1 release

 -- Aveen Ismail <aveen.ismail@yubico.com>  Mon, 20 Jul 2020 10:57:43 +0100

yubico-piv-tool (2.1.0) stable; urgency=medium

  * 2.1.0 release

 -- Aveen Ismail <aveen.ismail@yubico.com>  Mon, 8 Jun 2020 11:19:47 +0100

=== debian/control ===
Source: yubico-piv-tool
Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
Uploaders: Simon Josefsson <simon@josefsson.org>, Klas Lindfors <klas@yubico.com>, Dain Nilsson <dain@yubico.com>, Alessio Di Mauro <alessio@yubico.com>, Aveen Ismail <aveen.ismail@yubico.com>
Section: utils
Priority: extra
Build-Depends: debhelper (>= 9), pkg-config, libpcsclite-dev, libssl-dev, gengetopt, help2man, dh-autoreconf, chrpath, check, cmake (>=3.5)
Standards-Version: 4.1.4
Homepage: https://developers.yubico.com/yubico-piv-tool/

Package: libykpiv1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pcscd
Replaces: libykpiv0
Conflicts: libykpiv0
Description: Library for communication with the YubiKey PIV
 application. The Yubico PIV tool is used for interacting with the
 Personal Identity Verification Card (PIV) application on a YubiKey.
 With it you may generate keys on the device, import keys and
 certificates, create certificate requests, and other operations. A
 shared library, a PKCS#11 module a command-line tool are included.
 .
 This package contains the run-time shared library.  You normally don't
 need to install it manually.

Package: libykpiv-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libykpiv1 (= ${binary:Version})
Description: Library for communication with the YubiKey PIV
 application. The Yubico PIV tool is used for interacting with the
 Personal Identity Verification Card (PIV) application on a YubiKey.
 With it you may generate keys on the device, import keys and
 certificates, create certificate requests, and other operations. A
 shared library, a PKCS#11 module and a command-line tool are
 included.
 .
 This package contains the development files for the library.

Package: ykcs11
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libykpiv1 (= ${binary:Version})
Breaks: libykcs11-1 (<< 1.4.1~)
Replaces: libykcs11-1 (<< 1.4.1~)
Description: PKCS#11 module for communication with the YubiKey PIV
 application. The Yubico PIV tool is used for interacting with the
 Personal Identity Verification Card (PIV) application on a YubiKey.
 With it you may generate keys on the device, import keys and
 certificates, create certificate requests, and other operations. A
 shared library, a PKCS#11 module and a command-line tool are
 included.
 .
 This package contains the PKCS#11 module.

Package: libykcs11-1
Architecture: all
Section: oldlibs
Depends: ykcs11, ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: yubico-piv-tool
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Command line tool for the YubiKey PIV application. The
 Yubico PIV tool is used for interacting with the Personal Identity
 Verification Card (PIV) application on a YubiKey. With it you may
 generate keys on the device, import keys and certificates, create
 certificate requests, and other operations. A shared library, a
 PKCS#11 module and command-line tool are included.
 .
 This package contains the command-line tool.
